; Inno Setup installer script
#define MyAppName "Pro Custodibus Agent"
#define MyAppVersion "1.8.0"
#define MyServiceName "ProCustodibusAgent"
#define MyServiceDefault "Service"
#define MyServiceExe "ProCustodibusAgentService.exe"
#define MySourceDir ".."
#define MyX64ExeDir "..\build\exe.win-amd64-3.12"

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{EBA087D2-BA25-4E0B-A5FB-3DDC676D0D50}
AppName={#MyAppName}
AppVersion={#MyAppVersion}
AppPublisher=Arcem Tene, Inc.
AppPublisherURL=https://www.arcemtene.com/
AppSupportURL=https://www.procustodibus.com/support/
AppUpdatesURL=https://docs.procustodibus.com/guide/agents/download/
ArchitecturesAllowed=x64compatible
ArchitecturesInstallIn64BitMode=x64compatible
DefaultDirName={autopf}\{#MyAppName}
DefaultGroupName={#MyAppName}
LicenseFile={#MySourceDir}\LICENSE
OutputDir={#MySourceDir}\dist
OutputBaseFilename=ProCustodibusAgentInstaller
SetupIconFile={#MySourceDir}\installer\favicon.ico
Compression=lzma
SolidCompression=yes
WizardStyle=modern

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Dirs]
Name: "{app}\cnf"
Name: "{app}\log"

[Files]
Source: "{#MyX64ExeDir}\*"; \
    DestDir: "{app}"; \
    Flags: ignoreversion recursesubdirs createallsubdirs
Source: "{#MySourceDir}\LICENSE"; \
    DestDir: "{app}"; \
    Flags: ignoreversion
Source: "{#MySourceDir}\installer\favicon.ico"; \
    DestDir: "{app}"; \
    Flags: ignoreversion
Source: "{#MySourceDir}\installer\help.url"; \
    DestDir: "{app}"; \
    Flags: ignoreversion
Source: "{#MySourceDir}\installer\troubleshooting.url"; \
    DestDir: "{app}"; \
    Flags: ignoreversion
Source: "{#MySourceDir}\scripts\windows\*"; \
    DestDir: "{app}\scripts"; \
    Flags: ignoreversion recursesubdirs createallsubdirs

[Icons]
Name: "{group}\{#MyAppName} Test"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k ""{app}\procustodibus-agent.exe"" --test"; \
    Flags: dontcloseonexit
Name: "{group}\{#MyAppName} Version"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k ""{app}\procustodibus-agent.exe"" --version"; \
    Flags: dontcloseonexit
Name: "{group}\{#MyAppName} MFA Status"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k ""{app}\procustodibus-mfa.exe"""; \
    Flags: dontcloseonexit
Name: "{group}\{#MyAppName} Service Start"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k sc start {#MyServiceName}{#MyServiceDefault}"; \
    Flags: dontcloseonexit
Name: "{group}\{#MyAppName} Service Stop"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k sc stop {#MyServiceName}{#MyServiceDefault}"; \
    Flags: dontcloseonexit
Name: "{group}\{#MyAppName} Service Status"; \
    IconFilename: "{app}\favicon.ico"; \
    Filename: "cmd"; \
    Parameters: "/k sc query {#MyServiceName}{#MyServiceDefault}"; \
    Flags: dontcloseonexit
Name: "{group}\Help"; \
    Filename: "{app}\help.url"
Name: "{group}\Troubleshooting"; \
    Filename: "{app}\troubleshooting.url"
Name: "{group}\Configuration"; \
    Filename: "{app}\cnf"
Name: "{group}\Logs"; \
    Filename: "{app}\log"

[Run]
Filename: "{app}\{#MyServiceExe}"; \
    StatusMsg: "Installing Windows Service ... "; \
    Parameters: "--install {#MyServiceDefault}";  \
    Flags: runhidden waituntilterminated
Filename: "sc"; \
    StatusMsg: "Configuring Windows Service ... "; \
    Parameters: "config {#MyServiceName}{#MyServiceDefault} start=delayed-auto";  \
    Flags: runhidden waituntilterminated
Filename: "sc"; \
    StatusMsg: "Running Windows Service ... "; \
    Parameters: "start {#MyServiceName}{#MyServiceDefault}";  \
    Flags: runhidden waituntilterminated

[UninstallRun]
Filename: "{app}\{#MyServiceExe}"; \
    Parameters: "--uninstall {#MyServiceDefault}";  \
    Flags: runhidden; RunOnceId: "Remove"
